
#include <exception>

#include "Adc64Core.h"
#include "Adc64MainWindow.h"
#include "adc64-common/Adc64StartupOptions.h"
#include "base/app/DaqGuiApp.h"
#include "Adc64App.h"
#include "base/app/RunGuard.h"
#include "base/Globals.h"
#include "mongo/PrintConfigMap.h"

int main(int argc, char *argv[])
{
    Globals::setDaqModuleType(DaqModule::Type::Adc64);
    Adc64App daqApp(argc, argv);
    daqApp.init();

    if(daqApp.hasConfigListOpt())
        printConfigMap();

    RunGuard::runSingleOrExit();

    int res = 1;
    try {
        Adc64MainWindow *mw = nullptr;
        if (daqApp.isGuiApp()) {
            mw = new Adc64MainWindow(daqApp.getStartupOptions());
            mw->show();
        }
        Adc64Core core;
        res = daqApp.exec();
        delete mw;
    } catch (std::exception &e) {
        qCritical() << "Exception: " << e.what ();
    } catch (...) {
        qCritical() << "Unknown exception";
    }
    return res;
}
