#include "FileWatcherConfigDb.h"

#include "FileWatcherConfigConverter.h"


FileWatcherConfigDb::FileWatcherConfigDb(const QString &predefinedPath, QObject *parent)
    : AbstractConfigDb(parent)
    , predefinedPath(predefinedPath)
{
    AbstractConfigConverter<FileWatcherConfig>::registerTypes();
}

void FileWatcherConfigDb::setConfig(const FileWatcherConfig &newConfig)
{
    if(!initialized)
        return;
    if (newConfig == config)
        return;
    config = newConfig;

    auto json = QVariant::fromValue(config).value<QJsonObject>();
    write_config(json);
}

void FileWatcherConfigDb::update_config_from_db()
{
    auto conf_json = BaseConfig::readConfig(cs);
    config = QVariant::fromValue(conf_json).value<FileWatcherConfig>();
    if(!predefinedPath.isEmpty() && config.filePath != predefinedPath) {
        auto configNew = config;
        configNew.filePath = predefinedPath;
        setConfig(configNew);
    }
    emit configChanged(config);
}
