//
//    Copyright 2013 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef TTBREGS_H
#define TTBREGS_H

#include "config/params.h"

enum {
    REG_CONTROL = 0x40,
    REG_TTB_CSR_BASE = 0x0100,
    REG_TTB_CSR_CTRL            = REG_TTB_CSR_BASE + 0,
    REG_TTB_CSR_STATUS          = REG_TTB_CSR_BASE + 1,
    REG_TTB_CSR_LINK_EN         = REG_TTB_CSR_BASE + 2,
    REG_TTB_CSR_LINK_UP         = REG_TTB_CSR_BASE + 3,
    REG_TTB_CSR_LINK_ERRDISABLE = REG_TTB_CSR_BASE + 4,
    REG_TTB_CSR_LINK_BUSY_BIT   = REG_TTB_CSR_BASE + 5,
    REG32_TTB_CSR_EVENT_NR      = REG_TTB_CSR_BASE + 8, // Spill Event Num
    REG32_TTB_RJTTC_ERRDISABLE_RECOVERY_TIME = REG_TTB_CSR_BASE + 0xA,
    REG_TTB_RJTTC_ERRDISABLE_CTRL = REG_TTB_CSR_BASE + 0xC,
    REG32_TTB_CSR_SPILL_NUM       = REG_TTB_CSR_BASE + 0xE, // Spill num
    REG64_TTB_GLOB_EVENT_NUM      = REG_TTB_CSR_BASE + 0x1C, // Global evNum

    // TODO // last decoded word from hrb + isKSymbol + some states
    REG_TTB_RJTTC_RX_STATUS_BASE = REG_TTB_CSR_BASE + 16,
    REG_TTB_RJTTC_RX_STATUS_NUM = TTB_CH_COUNT,

    REG_TTB_UTC_BASE = 0x0300,
    REG64_TTB_UTC_TS_A = 0x0,
    REG64_TTB_UTC_SET = 4,
    REG64_TTB_UTC_TS_B = 0x8,
    REG64_TTB_UTC_TS_LOCAL = 0xC,

    REG64_TTB_CNT_SPILL    = 0x1000,
    REG64_TTB_CNT_BUSY_TTB = 0x1004,
    REG64_TTB_CNT_BUSY_CH0 = 0x1008
};

enum {
    REG_TTB_COUNTERS_BASE = 0x0200,
    REG_TTB_COUNTERS_NUM  = 140, // number of 32-bit registers

    REG32_TTB_ETTC_ERROR  = 0x0,
    REG32_TTB_TTC_TRIG  = 0x2,
    REG32_TTB_ETH_RX_ERROR  = 0x8,
    REG32_TTB_ETH_TX_ERROR  = 0xA,
    REG32_TTB_ETH_REGIO_ERROR  = 0xC,
    REG32_TTB_ETH_REGIO_TIMEOUT  = 0xE,
    REG32_TTB_STAT_LINK_UP  = 0x20,
    REG32_TTB_STAT_LINK_ERROR  = 0x40,
    REG32_TTB_STAT_LINK_TIMEOUT  = 0x60,
    REG32_TTB_STAT_LINK_ERR_DISABLE  = 0x80,

    REG32_TTB_STAT_LINK_ERR_DISABLE_SET  = 0xA0,
    REG32_TTB_STAT_LINK_ERR_DISABLE_UNSET  = 0xC0,
    REG32_TTB_STAT_LINK_ERR_DISABLE_MSTREAM  = 0xE0,
};

#endif // TTBREGS_H
