#include "EvbCombinerConfig.h"

#include <QDebug>
#include <QDataStream>

QDebug operator<<(QDebug dbg, const COMBINER_OUT &c)
{
    switch (c) {
    case COMBINER_FILE : dbg << "File"; break;
    case COMBINER_TCP: dbg << "Tcp"; break;
    case COMBINER_IDLE: dbg << "Idle"; break;
    }
    return dbg;
}

QDebug operator<<(QDebug dbg, const EvbCombinerConfig &c)
{
    dbg << "combinerOut:" << c.combinerOut
        << "combinerOutTcpNum:" << c.combinerOutTcpNum
        << "outputBufSize:" << c.outputBufSize
        << "infOutputEn:" << c.infOutputEn
        << "timeDistrEn:" << c.timeDistrEn
        << "fixTlvFormat:" << c.fixTlvFormat;

    return dbg;
}

QDataStream &operator<<(QDataStream &out, const EvbCombinerConfig &r)
{
    out
            << static_cast<int>(r.combinerOut)
            << r.combinerOutTcpNum
            << r.outputBufSize
            << r.infOutputEn
            << r.timeDistrEn
            << r.fixTlvFormat;

    return out;
}

QDataStream &operator>>(QDataStream &in, EvbCombinerConfig &r)
{
    int combinerOut;
    in
            >> combinerOut
            >> r.combinerOutTcpNum
            >> r.outputBufSize
            >> r.infOutputEn
            >> r.timeDistrEn
            >> r.fixTlvFormat;
    r.combinerOut = static_cast<COMBINER_OUT>(combinerOut);
    return in;
}
