#include "EvbWriterConfig.h"

#include <QDebug>
#include <QDataStream>
#include <QRegularExpression>

QDebug operator<<(QDebug dbg, const EvbWriterConfig &c)
{
    dbg << "writerCfg:" << c.storageDir
        << "filePrefix:" << c.filePrefix
        << "addRunIndex:" << c.addRunIndex
        << "addRunNumber:" << c.addRunNumber
        << "addLocalProgramIndex:" << c.addLocalProgramIndex
        << "addTimestamp:" << c.addTimestamp
        << "protectFile:" << c.protectFile;
    return dbg;
}

QDataStream &operator<<(QDataStream &out, const EvbWriterConfig &r)
{
    out
            << r.storageDir
        << r.filePrefix
        << r.addRunIndex
        << r.addRunNumber
        << r.addLocalProgramIndex
        << r.addTimestamp
            << r.protectFile;
    return out;
}

QDataStream &operator>>(QDataStream &in, EvbWriterConfig &r)
{
    in
            >> r.storageDir
        >> r.filePrefix
        >> r.addRunIndex
        >> r.addRunNumber
            >> r.addLocalProgramIndex
        >> r.addTimestamp
            >> r.protectFile;
    return in;
}

void EvbWriterConfig::fixFilePrefix()
{
    filePrefix.remove(QRegularExpression("[^\\w\\-\\.]"));
}
