#ifndef TCPCLIENTFSM_H
#define TCPCLIENTFSM_H

#include "BaseEvbClientFsm.h"

struct TcpClientFsmInput : public BaseFsmInput
{
    bool bufferCreated = false;
    bool connected = false;
    bool clientEn = false;
};

class TcpClientFsm : public BaseEvbClientFsm
{
    Q_OBJECT
public:
    explicit TcpClientFsm(QObject *parent = nullptr);
    void setRbCreated();
    void setConnected(bool connected);
    void setClientEn(bool clientEn);

protected:
    virtual void printInputString(QDebug dbg) const override;
    inline TcpClientFsmInput *getInput() {
        return static_cast<TcpClientFsmInput*>(BaseFsm::getInput());
    }
    inline const TcpClientFsmInput *getInput() const {
        return static_cast<const TcpClientFsmInput*>(BaseFsm::getInput());
    }

    bool hasAnyError() const final;
};

QDebug operator<<(QDebug dbg, const TcpClientFsmInput &in);

#endif // TCPCLIENTFSM_H
