/*
**    Copyright 2014-2018 Ivan Filippov
**    Copyright 2014-2020 Ilja Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef TRIGSOURCECONFIG_H
#define TRIGSOURCECONFIG_H

#include <QMetaType>
#include <QtGlobal>

class QDebug;
class QSettings;

struct TrigSourceConfig
{
    enum {TrigMaskTimer = 0x8000, TrigMaskRandom = 0x4000, TrigMaskLvds = 0x2000};
    friend bool operator==(const TrigSourceConfig &, const TrigSourceConfig &) = default;

    quint16 xOffMask = 0;
    bool trigOpen = true;
    quint16 trigSrc = 1;
};

Q_DECLARE_METATYPE(TrigSourceConfig)

#endif // TRIGSOURCECONFIG_H
