#ifndef CALIBRATIONDIALOG_H
#define CALIBRATIONDIALOG_H

#include <QDialog>

class CalibrationModel;
class CalResult;
class DeviceIndex;
class CalConfig;
class RemoteControlServerStatus;

enum class FsmState;

namespace Ui {
class CalibrationDialog;
}

class CalibrationDialog : public QDialog
{
    Q_OBJECT

public:
    explicit CalibrationDialog(QWidget *parent = nullptr);
    ~CalibrationDialog() override;
    CalibrationModel * getCalibrationModel() const  { return model; }

signals:
    void startCalibration();

public slots:
    void reset();
    void onFsmStateChange(const FsmState &state);
    void onRemoteStatusUpdated(const RemoteControlServerStatus &rcState);

private slots:
    void on_pushButtonCalibrate_clicked();
    void on_pushButtonClear_clicked();
    void on_pushButtonClose_clicked();

private:
    Ui::CalibrationDialog *ui;
    CalibrationModel * const model;
    bool underRemoteCtrl = false;
};

#endif // CALIBRATIONDIALOG_H
