#ifndef TQDCSTATUSDISPATCHER_H
#define TQDCSTATUSDISPATCHER_H

#include <QObject>
#include <QDebug>

#include "TqdcStatus.h"

// NOT USEFULL - TODEL
class TqdcStatusDispatcher : public QObject
{
    Q_OBJECT
    explicit TqdcStatusDispatcher(QObject *parent = nullptr);
public:
    // Singleton
    static TqdcStatusDispatcher & instance()
    {
        // thread-safe since C++11
        static TqdcStatusDispatcher obj;
        return obj;
    }
    // delete copy and move constructors and assign operators
    TqdcStatusDispatcher(TqdcStatusDispatcher const &) = delete;
    TqdcStatusDispatcher(TqdcStatusDispatcher &&) = delete;
    TqdcStatusDispatcher &operator=(TqdcStatusDispatcher const &) = delete;
    TqdcStatusDispatcher &operator=(TqdcStatusDispatcher &&) = delete;

    template<class T>
    void subscribeStatus(T *obj) {
            connect(this, &TqdcStatusDispatcher::statusChanged,
                    obj, &T::setConfig,
                    Qt::UniqueConnection);

            connect(obj, &T::configChanged,
                    this, &TqdcStatusDispatcher::setStatus,
                    Qt::UniqueConnection);
            logConnection(obj, "Status");
    }

signals:
    void statusChanged(const TqdcStatus &) const;

public slots:
    void setStatus(const TqdcStatus &newStatus);

private:
    std::unique_ptr<TqdcStatus> cache;
};

#endif // TQDCSTATUSDISPATCHER_H
