#ifndef STATUSDIALOG_H
#define STATUSDIALOG_H

#include <QDialog>

#include "histogramm/AnalyzerStat.h"

struct WorkerStat;

namespace Ui {
class StatusDialog;
}

class QTableWidget;

class StatusDialog : public QDialog
{
    Q_OBJECT

public:
    explicit StatusDialog(QWidget *parent = nullptr);
    ~StatusDialog();

public slots:
    void updateHitStats(const AnalyzerStat &stats);
    void updateWorkerStats(const WorkerStat &stats);
    void reset();

private slots:
    void on_checkBoxFreeze_toggled(bool checked);

private:
    void init();
    void log_info(const AnalyzerStat &stats);
    static void update_table_size(QTableWidget * const table, bool widthOnly=false);
    void update_indicator(qint64 dt);

    Ui::StatusDialog *ui;
    AnalyzerStat prevStat;
    AnalyzerStat pendingStat;
    bool show_skip_info;
    QElapsedTimer lastLogTimer;
    int loop;
    bool freeze;
};

#endif // STATUSDIALOG_H
