/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef DAQGUIAPP_H
#define DAQGUIAPP_H

#include "DaqBaseApp.h"

class DaqGuiAppPrivate;

class DaqGuiApp : public DaqBaseApp
{
public:
    DaqGuiApp(int &_argc, char *_argv[]);
    ~DaqGuiApp() override;
    virtual void init() override;

//    QCoreApplication *getApp() { return app.data(); }
    int exec() override;
    bool isGuiApp() const { return !option_no_gui; }

protected:
    virtual void setupOptions() override;
    virtual void processParseResults(QCommandLineParser &parser) override;
    virtual QCoreApplication *createApplication() const override;
    virtual QPixmap getSplashPixmap() const;

    bool option_no_gui = false;

private:
    Q_DISABLE_COPY(DaqGuiApp)
//    void initBaseConfig();
    void initStyle();
    void showSplashScreen();
    void hideSplashScreen();

    Q_DECLARE_PRIVATE(DaqGuiApp)
    DaqGuiAppPrivate * const d_ptr;
    QCommandLineOption noguiOption;
};

#endif // DAQGUIAPP_H
