/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef DEVICEDISPATCHERFILTER_H
#define DEVICEDISPATCHERFILTER_H

#include <QObject>
#include "base/DeviceIndex.h"

class QHostAddress;

class DeviceDispatcherFilter : public QObject
{
    Q_OBJECT
public:
    DeviceDispatcherFilter(const DeviceIndex &index, QObject *parent = nullptr)
        : QObject(parent), index(index) {}
public slots:
    void setHostAddress(const DeviceIndex &index, const QHostAddress &address, int ttl)
    {
        if (index == this->index)
            emit setHostAddressFiltered(index, address, ttl);
    }
    void destroy(const DeviceIndex &i, QObject *_parent = nullptr) {
        if(index != i)
            return;
        if(_parent && _parent != parent())
            return;
        deleteLater();
    }
signals:
    void setHostAddressFiltered(const DeviceIndex &, const QHostAddress &, int);
private:
    const DeviceIndex index;
};

#endif // DEVICEDISPATCHERFILTER_H
