#ifndef DEVICEIDLISTWIDGET_H
#define DEVICEIDLISTWIDGET_H

#include <QListWidget>
#include <QMap>

#include "base/DeviceIndex.h"

class LldpInfoCache;

class DeviceIdListWidget : public QListWidget
{
    Q_OBJECT
public:
    explicit DeviceIdListWidget(QWidget *parent = nullptr);
    void addDeviceId(quint16 id, const QString &name = {}, const QString &description = {});

signals:
    void setDeviceIdFilter(const DeviceIdSet &filter);

public slots:
    void lldpCacheUpdated(const LldpInfoCache &cache);

protected:
    void selectionChanged(const QItemSelection &selected, const QItemSelection &deselected) override;

private:
    QMap<quint16, QStringList> knownTypes;
};

#endif // DEVICEIDLISTWIDGET_H
