#ifndef DDR3STREAMFIFOSTATUS_H
#define DDR3STREAMFIFOSTATUS_H

#include <QtCore>

typedef union {
    quint16 all;
    struct {
        quint32 empty: 1;      // [0]
        quint32 full: 1;     // [1]
        quint32 initCalComplete: 1;   // [2]
        quint32 unused: 13;    // [15:3]
    } bit;
} reg_ddr3_status_code;

inline bool operator==(const reg_ddr3_status_code &l, const reg_ddr3_status_code &r)
{
    return l.all == r.all;
}

struct Ddr3StreamFifoStatus
{
    friend bool operator==(const Ddr3StreamFifoStatus &, const Ddr3StreamFifoStatus &) = default;

    quint64 fullMem() const { return quint64(1) << fullMemRaw ;}

    reg_ddr3_status_code statusCode = {0};
    quint16 fullMemRaw = 0;
    quint64 fifoOccup = 0;
    quint32 eccMulti = 0;
    quint32 eccSingle = 0;
};

#endif // DDR3STREAMFIFOSTATUS_H
