#ifndef DESERIALIZERSCONTROLSTATUS_H
#define DESERIALIZERSCONTROLSTATUS_H

#include <QVector>

struct DeserializersControlStatus
{
    friend bool operator==(const DeserializersControlStatus &, const DeserializersControlStatus &) = default;
    bool isOk() const
    {
        for(int i=0; i<desCnt; ++i) {
            if(!isDesOk(i))
                return false;
        }
        return true;
    }
    bool isDesOk(int desId) const
    {
        return desId<desCnt && lockState[desId] && !unlockDetected[desId];
    }

    void setStatus(quint16 _regVal)
    {
        regVal = _regVal;
        lockState.resize(desCnt);
        unlockDetected.resize(desCnt);
        for(int i=0; i<desCnt; ++i) {
            lockState[i] = (regVal>>(2*i)) & 1;
            unlockDetected[i] = (regVal>>(2*i+1)) & 1;
        }
    }
    QString toString() const {
        return QString("%1").arg(regVal,desCnt*2,2,QChar('0'));
        QString s;
        for(int id=0; id<desCnt; ++id)

        return s;
    }
    void clear() { setStatus(0); }

    QVector<bool> lockState;
    QVector<bool> unlockDetected;
    int desCnt = 0;
    quint16 regVal = 0;
};

#endif // DESERIALIZERSCONTROLSTATUS_H
