/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "FirFilterConfig.h"

namespace {
const int FIR_ROUNDOFF_DEFAULT = 0x0001;
}

FirFilterConfig::FirFilterConfig()
    : roundoff(FIR_ROUNDOFF_DEFAULT)
{
    coef.resize(16);
    coef[0] = 32767;
}

void FirFilterConfig::setRoundoff(int value)
{
    if (value < 0)
        value = 0;
    if (value > getRoundoffMax())
        value = getRoundoffMax();
    roundoff = value;
}
