#ifndef MLINKCSRSTATUS_H
#define MLINKCSRSTATUS_H

#include <QtCore>

#include "base/fw_version.h"

enum DeviceId : uint8_t;

struct MlinkCsrStatus
{
    friend bool operator==(const MlinkCsrStatus &, const MlinkCsrStatus &) = default;
    QMap<QString, double> getTemps() const { return temps; }
    QString getHwStr() const { return hw_version.toString(); }

    DeviceId device_id = {};
    bool id_chip_present = false;
    quint64 device_serial = 0;
    QMap<QString, double> temps;
    fw_version_t fw_version;
    fw_version_t hw_version;
};

#endif // MLINKCSRSTATUS_H
