#include "StatPresetConverter.h"

#include "base/ConfigConverterUtil.h"

#include "StatPreset.h"

namespace {
constexpr const char *k_type = "type";
constexpr const char *k_label = "label";
constexpr const char *k_regs = "regs";
}

template<>
bool AbstractConfigConverter<StatPreset>::classIsObject()
{
//    return true;
    return false;
}

template<>
QJsonObject AbstractConfigConverter<StatPreset>::toJsonObject(const StatPreset &in)
{
    QVariantMap m;
    m[k_type] = QVariant::fromValue(static_cast<int>(in.type));
    m[k_label] = QVariant::fromValue(in.label);
    m[k_regs] = ConfigConverterUtil::toJsonValue(in.regs);
    return fromVariantMap(m);
}

template<>
StatPreset AbstractConfigConverter<StatPreset>::fromJsonObject(const QJsonObject &in)
{
    StatPreset out;
    out.type = static_cast<StatPreset::STAT_TYPE>(in[k_type].toInt());
    update_value(in, k_label, &out.label);
    out.regs = ConfigConverterUtil::toVector<quint16>(in[k_regs]);
    return out;
}

template<>
QJsonValue AbstractConfigConverter<StatPreset>::toJsonValue(const StatPreset &in)
{
    return toJsonObject(in);
}

template<>
StatPreset AbstractConfigConverter<StatPreset>::fromJsonValue(const QJsonValue &in)
{
//    return StatPresetFabric::getPreset(in.toString());
    return fromJsonObject(in.toObject());
}

template<>
void AbstractConfigConverter<StatPreset>::registerSubTypes()
{
}
