#include "TdcCoreConfig.h"

#include <QDebug>
#include <QJsonObject>

bool HptdcAdjustConfig::mode_rc_compression() const
{
    return resolution == TDC_RES_INDEX_25;
}

bool HptdcAdjustConfig::mode_rc() const
{
    return resolution == TDC_RES_INDEX_25_UNPACKED || resolution == TDC_RES_INDEX_25;
}

quint16 HptdcAdjustConfig::leading_resolution() const
{
    switch (resolution) {
    case TDC_RES_INDEX_100:
        return 0;
    case TDC_RES_INDEX_200:
        return 1;
    case TDC_RES_INDEX_400:
        return 2;
    case TDC_RES_INDEX_800:
        return 3;
    case TDC_RES_INDEX_1600:
        return 4;
    default:
        return 0;
    }
}

quint16 HptdcAdjustConfig::dll_mode() const
{
    // 0->40MHz, 1->160MHz, 2->320MHz
    switch (resolution) {
    case TDC_RES_INDEX_100:
        return 2;
    case TDC_RES_INDEX_200:
        return 1;
    case TDC_RES_INDEX_400:
        return 1;
    case TDC_RES_INDEX_800:
        return 0;
    case TDC_RES_INDEX_1600:
        return 0;
    default:
        return 2;
    }
}

quint16 HptdcAdjustConfig::dll_clock() const
{
    // 0->clk_40, 1->pll_40, 2->pll_160, 3->pll_320
    switch (resolution) {
    case TDC_RES_INDEX_100:
        return 3;
    case TDC_RES_INDEX_200:
        return 2;
    case TDC_RES_INDEX_400:
        return 2;   // 2 - med res
    case TDC_RES_INDEX_800:
        return 1;   // 2 - med res
    case TDC_RES_INDEX_1600:
        return 1;   // 1 - low res
    default:
        return 3;
    }
}

QDebug operator<<(QDebug dbg, const HptdcAdjustConfig &s)
{
    dbg << QVariant::fromValue(s).value<QJsonObject>(); // convert to JSON
    return dbg;
}

QDebug operator<<(QDebug dbg, const TdcCoreConfig &s)
{
    dbg << QVariant::fromValue(s).value<QJsonObject>(); // convert to JSON
    return dbg;
}
