#ifndef TDCCOREMODULE_H
#define TDCCOREMODULE_H

#include <optional>

#include "device-modules/BaseDeviceModule.h"
#include "TdcCoreConfig.h"

struct TdcCoreStatus;
struct HptdcAdjustConfig;

//const QList<QPair<QString, int>> LEAD_RES_VALUES = {
//    {"clock_40",      0b000},
//    {"pll_clock_40",  0b001},
//    {"pll_clock_160", 0b010},
//    {"pll_clock_320", 0b011},
//    {"aux_clock",     0b100}
//};

class TdcCoreModule : public BaseDeviceModule<TdcCoreModule>
{
public:
    explicit TdcCoreModule(const MregBusInterface &bus);

    static QList<AFI_SDB_ID> getSupportedSdbIds();

    bool writeConfig(const TdcCoreConfig &newConfig);
    std::optional<TdcCoreStatus> readStatus();

protected:
    void post_init() override;

private:
    int getNch() const;
    int getNchPerChip() const;
    std::vector<quint32> getChMask() const;
    mlink::RegOpVector getStatusRegOp(TdcCoreStatus &result) const;

    bool waitHptdcInit();
    bool waitHptdcReady();
    bool waitHptdcState(quint32 state);
    bool setStandby(bool standBy);
    bool setChEnMask();
    bool writeHptdcSetup();
    bool vhrOnlyMode() const;

    int chipNum = 0;
    TdcCoreConfig config;
};

#endif // TDCCOREMODULE_H
