#ifndef TLU40LVDSTOFTRIGGERMODULE_H
#define TLU40LVDSTOFTRIGGERMODULE_H

#include "device-modules/BaseDeviceModule.h"

#include <optional>

#include "Tlu40LvdsTofTriggerBuildParams.h"
#include "Tlu40LvdsTofTriggerConfig.h"
#include "Tlu40LvdsTofTriggerStatus.h"

class Tlu40LvdsTofTriggerModule : public BaseDeviceModule<Tlu40LvdsTofTriggerModule>
{
public:
    explicit Tlu40LvdsTofTriggerModule(const MregBusInterface &bus) : BaseDeviceModule(bus) {}

    static QList<AFI_SDB_ID> getSupportedSdbIds();

    bool writeConfig(const Tlu40LvdsTofTriggerConfig &config);
    std::optional<Tlu40LvdsTofTriggerStatus> readStatus();
    std::optional<Tlu40LvdsTofTriggerBuildParams> getBuildParam() const {
        return buildParams;
    }

protected:
    void post_init() override;

private:
    std::optional<Tlu40LvdsTofTriggerBuildParams> buildParams;

};

#endif // TLU40LVDSTOFTRIGGERMODULE_H
