#include "TluDecDesStatus.h"

#include <QMap>

namespace {
static const QVector<QStringList> STATUS_PREFIXES = {
    {"deserializer unlocked", "deserializer locked"},
    {"link sync err (rx code errors)", "link sync ok (no rx code errors)"},
    {"frame sync err", "frame sync ok"},
};
}
QStringList TluDecDesChStatus::getStatusStringList() const {
    QStringList ret;
    for(auto i=0; i<3; ++i) {
        auto v = (status>>i) & 1;
        ret << QString("%1%2%3 - %4")
                   .arg("", 2-i, 'x')
                   .arg(v).arg("", i, 'x')
                   .arg(STATUS_PREFIXES.value(i).value(v));
    }
    // if((status & (1<<0)) == 1)
    //     ret << "xx1 - deserializer locked";
    // if((status & (1<<1)) == 1)
    //     ret << "x1x - link sync ok (no rx code errors)";
    // if((status & (1<<2)) == 1)
    //     ret << "1xx - frame sync ok";
    return ret;
}
