/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "TrigCtrlStatStatus.h"
#include "sdb/AfiSdbId.h"

namespace {
inline constexpr const uint16_t STATUS_BIT_READOUT = 0x01;
inline constexpr const uint16_t STATUS_BIT_TDC = 0x02;
inline constexpr const uint16_t STATUS_BIT_ADC = 0x04;
inline constexpr const uint16_t STATUS_BIT_EXT = 0x08;
inline constexpr const uint16_t STATUS_BIT_DEADTIME = 0x10;
} // namespace

bool TrigCtrlStatStatus::isValid() const
{
    return id == AFI_SDB_TDC_Trigger_Control;
}
