#ifndef FELINKTREEVIEW_H
#define FELINKTREEVIEW_H

#include <QTreeView>
#include "base/DeviceIndex.h"

class QSettings;

class DeviceIndex;
class SpinBoxDelegate;
class PhyResetButtonDelegate;

class FeLinkTreeView : public QTreeView
{
    Q_OBJECT
public:
    explicit FeLinkTreeView(QWidget *parent = nullptr);
    virtual void setModel(QAbstractItemModel *model) override;
    void saveAppGuiSettings(QSettings &) const;
    void loadAppGuiSettings(const QSettings &);
    QSize sizeHint() const override;

private slots:
    void expanded(const QModelIndex &index);
    void collapsed(const QModelIndex &index);
    void onModelReset();
    void addDelegate(const QModelIndex &index);

public slots:
    void expandTopItem();

private:
    DeviceIndex getDeviceIndex(const QModelIndex &index) const;
    int recursiveRowHeight(const QModelIndex &index) const;

    QMap<DeviceIndex, bool> expand_device_map;
    PhyResetButtonDelegate * const phyResetPbDelegate;
};

#endif // FELINKTREEVIEW_H
