#include "HptdcStatusMetrics.h"

#include <QMap>
#include <QString>

const QMap<HptdcStatusMetrics::Metric, QString> HPTDC_STATUS_METRICS =
{
    {HptdcStatusMetrics::Metric::Default, "default"},
    {HptdcStatusMetrics::Metric::VernierError, "Vernier Error"},
    {HptdcStatusMetrics::Metric::CoarseError, "Coarse Error"},
    {HptdcStatusMetrics::Metric::ChannelSelectError, "Channel Select Error"},
    {HptdcStatusMetrics::Metric::L1BufParityError, "L1 Buffer Parity Error"},
    {HptdcStatusMetrics::Metric::TriggerFIFOParityError, "Trigger FIFO Parity Error"},
    {HptdcStatusMetrics::Metric::TriggerMatchingStateError, "Trigger Matching State Error"},
    {HptdcStatusMetrics::Metric::ReadoutFIFOParityError, "Readout FIFO Parity Error"},

    {HptdcStatusMetrics::Metric::ReadoutStateError, "Readout State Error"},
    {HptdcStatusMetrics::Metric::SetupParityError, "Setup Parity Error"},
    {HptdcStatusMetrics::Metric::ControlParityError, "Control Parity Error"},

    {HptdcStatusMetrics::Metric::JtagInstructionError, "JTAG Instruction Error"},
    {HptdcStatusMetrics::Metric::TdcHaveReadoutToken, "TDC have Readout Token"},
    {HptdcStatusMetrics::Metric::ReadoutFIFOFull, "Readout FIFO full"},
    {HptdcStatusMetrics::Metric::ReadoutFIFOEmpty, "Readout FIFO empty"},

    {HptdcStatusMetrics::Metric::ReadoutFIFOOccupancy, "Readout FIFO Occupancy"},
    {HptdcStatusMetrics::Metric::TriggerFIFOOccupancy, "Trigger FIFO Occupancy"},
    {HptdcStatusMetrics::Metric::DllLock, "DLL Lock"},
    {HptdcStatusMetrics::Metric::InvertedSetupBit601, "Inverted Setup Bit 601"},

    {HptdcStatusMetrics::Metric::OccupancyOfL1BufferOfChannelGroup0,
    "Occupancy of L1 Buffer of channel group 0"},
    {HptdcStatusMetrics::Metric::OccupancyOfL1BufferOfChannelGroup1,
    "Occupancy of L1 Buffer of channel group 1"},
    {HptdcStatusMetrics::Metric::OccupancyOfL1BufferOfChannelGroup2,
    "Occupancy of L1 Buffer of channel group 2"},
    {HptdcStatusMetrics::Metric::OccupancyOfL1BufferOfChannelGroup3,
    "Occupancy of L1 Buffer of channel group 3"},
};

QString HptdcStatusMetrics::toString() const {
    return HPTDC_STATUS_METRICS.value(metric);
}

void HptdcStatusMetrics::setMetric(Metric metric_)
{
    metric = metric_;
}
