/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef NETWORKPORTCONFIGDIALOG_H
#define NETWORKPORTCONFIGDIALOG_H

#include <QDialog>
#include "device-modules/NetworkPort/NetworkPortConfig.h"

class NetworkPortWidget;
class NetworkPortConfigDialog : public QDialog
{
    Q_OBJECT
public:
    explicit NetworkPortConfigDialog(QWidget *parent = nullptr);

signals: void networkPortConfigChanged(const NetworkPortConfig &config) const;
public slots: void setNetworkPortConfig(const NetworkPortConfig &config);

private slots:
    void apply();
    void restoreDefaults();
    void discard();
    void mstreamReset();

private:
    NetworkPortWidget * const widget;
    NetworkPortConfig cache;
};

#endif // NETWORKPORTCONFIGDIALOG_H
