#ifndef TTLIOWIDGET_H
#define TTLIOWIDGET_H

#include <QWidget>

#include "device-modules/TtlIo/TtlIoConfig.h"
#include "fsm/FsmState.h"

namespace Ui {
class TtlIoWidget;
}

class QLabel;
class QComboBox;

class SingleTtlWidget : public QWidget
{
    Q_OBJECT
public:
    SingleTtlWidget(int id, QWidget *parent = nullptr);
    ~SingleTtlWidget();
    void setRegConfig(const reg_ttl_io_t &regCfg);

    int id;
    QLabel * const lab;
    QComboBox * const cb;
};

class TtlIoWidget : public QWidget
{
    Q_OBJECT

public:
    explicit TtlIoWidget(QWidget *parent = nullptr);
    ~TtlIoWidget();

public slots:
    void setStartUpCfg(const TtlIoConfig &sturtUpCfg);
    void setTtlCfg(const TtlIoConfig &ttlCfg);
    void onFsmStateChange(const FsmState &state);

private slots:
    void ttlItemChanged(int index);

signals:
    void ttlCfgChanged(const TtlIoConfig &config);

private:
    void addTtl(reg_ttl_io_t r);
    void removeTtl();

    Ui::TtlIoWidget *ui;
    QVector<SingleTtlWidget*> singleTtlWidgets;
    TtlIoConfig cfg;
};

#endif // TTLIOWIDGET_H
