#include "FileReaderConfigConverter.h"

#include "FileReaderConfig.h"

namespace {
constexpr const char *k_lastFile = "lastFile";
constexpr const char *k_playbackInterval = "playbackInterval";
constexpr const char *k_readBy = "readBy";
}

template<>
bool AbstractConfigConverter<FileReaderConfig>::classIsObject()
{
    return true;
}

template<>
QJsonObject AbstractConfigConverter<FileReaderConfig>::toJsonObject(const FileReaderConfig &in)
{
    QVariantMap m;
    m[k_lastFile] = QVariant::fromValue(in.lastFile);
    m[k_playbackInterval] = QVariant::fromValue(in.playbackInterval);
    m[k_readBy] = QVariant::fromValue(in.readBy);
    return fromVariantMap(m);
}

template<>
FileReaderConfig AbstractConfigConverter<FileReaderConfig>::fromJsonObject(const QJsonObject &in)
{
    FileReaderConfig out;
    update_value(in, k_lastFile, &out.lastFile);
    update_value(in, k_playbackInterval, &out.playbackInterval);
    update_value(in, k_readBy, &out.readBy);
    return out;
}

template<>
QJsonValue AbstractConfigConverter<FileReaderConfig>::toJsonValue(const FileReaderConfig &in)
{
    return toJsonObject(in);
}

template<>
FileReaderConfig AbstractConfigConverter<FileReaderConfig>::fromJsonValue(const QJsonValue &in)
{
    return fromJsonObject(in.toObject());
}

template<>
void AbstractConfigConverter<FileReaderConfig>::registerSubTypes()
{
}
