/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef RUNCONTROLAPPCONFIG_H
#define RUNCONTROLAPPCONFIG_H

#include "BaseDeviceAppConfig.h"
#include "base/ClientIndexEnabled.h"
#include "base/RcProgramConfig.h"
#include "run-control-client-manager/config/RcClientConfig.h"

#include <QMap>
#include <QMetaType>

class RunControlAppConfig : public BaseDeviceAppConfig
{
public:
    friend bool operator==(const RunControlAppConfig &l, const RunControlAppConfig &r) = default;
    void removeInvalidEntries() override {
        BaseDeviceAppConfig::removeInvalidEntries();
        for(auto i : clients.keys())
            if(i.isEmpty())
                clients.remove(i);
    }

    RcProgramConfig pc;
    RcClientConfigMap clients;

    QMap<DeviceIndex, QString> custom_name;
};

Q_DECLARE_METATYPE(RunControlAppConfig)

#endif // RUNCONTROLAPPCONFIG_H
