/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef DEVICESTATUSTABLEVIEWFANCY_H
#define DEVICESTATUSTABLEVIEWFANCY_H

#include "DeviceStatusTableView.h"

class DeviceStatusTableViewFancy : public DeviceStatusTableView
{
    Q_OBJECT

public:
    explicit DeviceStatusTableViewFancy(QWidget *parent = nullptr);

signals:
    void showDeviceStatus(const DeviceIndex &deviceIndex);
    void rebootDevice(const DeviceIndex &deviceIndex);

public slots:
    void setControlEnabled(bool en);

protected slots:
    void setupDecorators();
    void horizontalHeaderPopup(const QPoint &pos);
    void cellPopup(const QPoint &pos);
    void actionDeviceStatus();
    void actionDeviceReboot();
    void hideColumnAction();
    void showAllColumnsSetAction();
    void setColumnSetAction();
    void showColumnAction();
    void toggleColumnAction();
    void selectionChanged(const QItemSelection &selected, const QItemSelection &deselected) override;

private:
    DeviceIndexSet getSelectedDeviceIndexes() const;
    DeviceIndexSet getActionDeviceIndexes() const;
    DeviceIndex getActionDeviceIndex() const;
    QSet<int> getColumnSetDefault() const;
    QSet<int> getColumnSet1() const;

    QMenu * const cellPopupMenu;
    QMenu * const headerPopupMenu;

    bool controlEnabled = true;
};

#endif // DEVICESTATUSTABLEVIEWFANCY_H
