/*
**    Copyright 2021 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef ABSTRACTPUBLISHER_H
#define ABSTRACTPUBLISHER_H

#include <QObject>

class DaqModule;
class ProgramIndex;

class AbstractPublisher : public QObject
{
    Q_OBJECT
public:
    explicit AbstractPublisher(QObject *parent = nullptr);

public slots:
    virtual void pub(const QString &key, const QByteArray &data) = 0;
    static QString makeKey(const DaqModule &module, const ProgramIndex &index);
};

#endif // ABSTRACTPUBLISHER_H
