/*
**    Copyright 2021 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef ZMQKVPUBLISHER_H
#define ZMQKVPUBLISHER_H

#include <zmq.hpp>
#include <QObject>
#include <QUrl>
#include "../AbstractPublisher.h"

class ZmqKvPublisher: public AbstractPublisher
{
    Q_OBJECT
public:
    ZmqKvPublisher(const QString &serviceName, QObject *parent = nullptr);
    ~ZmqKvPublisher();
    bool event(QEvent* ev) override;

public slots:
    void pub(const QString &key, const QByteArray &data) override;

private slots:
    void deferredConnect();

private:
    void createSocket();
    void deleteSocket();

    zmq::context_t &context;
    zmq::socket_t * sock = nullptr;
    bool enabled = true;
    QUrl url;
};

#endif // ZMQKVPUBLISHER_H
