/*
**    Copyright 2010-2022 Ilja Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef MREGDEVICE_H
#define MREGDEVICE_H

#include "regio/mlinkdevice.h"

enum AFI_SDB_ID : uint32_t;

class SdbDevice;
class sdb_t;

namespace mlink {

class MregDevice : public MlinkDevice
{
public:
    MregDevice(RegIOBase &p, int address, QObject *parent);
    ~MregDevice();

    bool detect();

    sdb_t getSdb() const;
    bool readSdb(uint32_t address);

private:
    sdb_t * const sdb;
};

} // namespace mlink

#endif // MREGDEVICE_H
