#ifndef POSTGRESDB_H
#define POSTGRESDB_H

#include "AbstractDB.h"

class ConfigSelector;
class ConfigDocument;
class DaqModule;
struct RcRunId;

class QDateTime;
class QJsonObject;
class QSqlDatabase;
class QSqlQuery;

class PostgresDB : public AbstractDB
{
public:
    PostgresDB() = default;
    virtual ~PostgresDB() override = default;
    void connectToDb();
    virtual ConfigDocument readConfigDocument(const ConfigSelector &cs) override;
    virtual bool writeConfigDocument(const ConfigDocument &cd) override;
    virtual bool writeConfigRun(const RcRunId &runId, const QJsonObject &jsonCfg) override; // toCheck
    virtual int delete_config(const ConfigSelector &cs) override; // toCheck
    virtual QMap<ProgramIndex, QMap<ConfigurationName, QDateTime> > get_config_map(const DaqModule &daq_module) override;

private:
    void initDb(QSqlDatabase *db);
    void logError(const char *funcName, const QSqlQuery &query);
    QSqlDatabase getDb();

    bool enabled = false;
};

#endif // POSTGRESDB_H
