#ifndef MONGODATABASE_H
#define MONGODATABASE_H

#include "MongoCollection.h"

#include <QMetaType>
#include <QString>
#include <QList>

class MongoCollection;

class MongoDatabase
{
public:
    MongoDatabase(QString db_name = "") :
        db_name(db_name)
    {
    }
    void clear(){
        db_name.clear();
        collections.clear();
        size = 0;
    }
    bool operator == (const MongoDatabase &db) const {
        return ((db.size == size) &&
                (db.db_name == db_name) &&
                (db.collections == db.collections));
    }
    bool isTest() const;
    bool isDaq() const;
    QString toString() const;

    QString db_name;
    QList<MongoCollection> collections;
    int size;
};
Q_DECLARE_METATYPE(MongoDatabase);

#endif // MONGODATABASE_H
