#include "PnpDiscovery.h"
#include "PnpDiscovery_p.h"

PnpDiscovery::PnpDiscovery()
    : QObject(nullptr),
    d_ptr(new PnpDiscoveryPrivate(this))
{
    Q_D(PnpDiscovery);
    d->q_ptr = this;

    connect(d, &PnpDiscoveryPrivate::cacheUpdated,
            this, &PnpDiscovery::cacheUpdated);

    connect(this, &PnpDiscovery::updateMyProgramDescription,
            d, &PnpDiscoveryPrivate::updateProgramDescription);

    connect(this, &PnpDiscovery::closeMyProgram,
            d, &PnpDiscoveryPrivate::closeMyProgram);

    connect(d, &PnpDiscoveryPrivate::gotProgramClosed,
            this, &PnpDiscovery::gotProgramClosed);
}

PnpDiscovery::~PnpDiscovery()
{
    delete d_ptr;
}

