/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef REMOTECONTROLPROTOCOL_H
#define REMOTECONTROLPROTOCOL_H

#include <QMetaType>
#include <QtGlobal>

#include "RunControlCommands.h"

;
#pragma pack(push, 1)
struct TypeLengthHeader {
    quint32 type;
    quint32 len;
};
#pragma pack(pop)

Q_DECLARE_METATYPE(TypeLengthHeader)

class QTcpSocket;
void send_rc_block(QTcpSocket *tcpSocket, quint32 type, const QByteArray &payload);
void send_rc_command(QTcpSocket *tcpSocket, const QStringList &commandList);
void send_rc_json(QTcpSocket *tcpSocket, const QJsonObject &obj);
void send_run_document(QTcpSocket *tcpSocket, const QByteArray &payload);

#endif // REMOTECONTROLPROTOCOL_H
